#ifndef NOTIFYICON_H_
#define NOTIFYICON_H_

// Class handling creation and deletion of shell notify icons
class NotifyIcon
{
public:
	// Create a new instance
	NotifyIcon(HICON icon, HWND hwnd, const TCHAR *tip, unsigned int id, unsigned int message)
	{
		// Fill the NOTIFYICONDATA structure
		ZeroMemory(&_data, sizeof(_data));

		_data.cbSize = sizeof(_data);
		_data.hIcon = icon;
		_data.hWnd = hwnd;
		_data.uCallbackMessage = message;
		_tcscpy_s(_data.szTip, tip);
		_data.uFlags = NIF_ICON | NIF_TIP | NIF_MESSAGE;
		_data.uID = id;

		RecreateIcon();
	}

	// Delete the notify icon when the class is destroyed
	virtual ~NotifyIcon()
	{
		OutputDebugString(TEXT("Deleting icon\n"));
		Shell_NotifyIcon(NIM_DELETE, &_data);
	}

	// Create the notify icon
	void RecreateIcon()
	{
		if( !Shell_NotifyIcon(NIM_ADD, &_data) )
			throw WindowsException(L"Could not create notify icon: ", GetLastError());
	}
private:

	NOTIFYICONDATA _data;
};

#endif